jQuery(document).ready(function () { 
        //Prepare jtable plugin
        jQuery('#DiscountsTableContainer').jtable({
            title: emediscounts.translate_discounts,
            paging: true,
            sorting: true,
            toolbarsearch: true,
            toolbarreset: false,
            jqueryuiTheme: true,
            defaultSorting: 'name ASC',
            selecting: true, //Enable selecting
            multiselect: true, //Allow multiple selecting
            selectingCheckboxes: true, //Show checkboxes on first column
            selectOnRowClick: true, //Enable this to only select using checkboxes
            deleteConfirmation: function(data) {
               data.deleteConfirmMessage = emediscounts.translate_pressdeletetoremove + ' "' + data.record.name + '"';
            },
            actions: {
                listAction: ajaxurl+'?action=eme_discounts_list',
                deleteAction: ajaxurl+'?action=eme_manage_discounts&do_action=deleteDiscounts&eme_admin_nonce='+emediscounts.translate_adminnonce
            },
            fields: {
                id: {
                    key: true,
                    create: false,
                    edit: false,
                    list: false
                },
                name: {
		    title: emediscounts.translate_name
                },
                description: {
		    title: emediscounts.translate_description
                },
                dgroup: {
		    title: emediscounts.translate_discountgroups
                },
                coupon: {
		    title: emediscounts.translate_coupon
                },
                strcase: {
		    title: emediscounts.translate_casesensitive,
                    searchable: false
                },
                use_per_seat: {
		    title: emediscounts.translate_use_per_seat,
                    searchable: false
                },
                value: {
		    title: emediscounts.translate_value
                },
                type: {
                    title: emediscounts.translate_type,
                    searchable: false
                },
                maxcount: {
		    title: emediscounts.translate_maxusage
                },
                count: {
		    title: emediscounts.translate_usage
                },
                valid_from: {
		    title: emediscounts.translate_validfrom
                },
                valid_to: {
		    title: emediscounts.translate_validto
                }
            }
        });

        jQuery('#DiscountGroupsTableContainer').jtable({
            title: emediscounts.translate_discountgroups,
            paging: true,
            sorting: true,
            jqueryuiTheme: true,
            defaultSorting: 'name ASC',
            toolbarsearch: true,
            toolbarreset: false,
            selecting: true, //Enable selecting
            multiselect: true, //Allow multiple selecting
            selectingCheckboxes: true, //Show checkboxes on first column
            selectOnRowClick: false, //Enable this to only select using checkboxes
            deleteConfirmation: function(data) {
               data.deleteConfirmMessage = emediscounts.translate_pressdeletetoremove + ' "' + data.record.name + '"';
            },
            actions: {
                listAction: ajaxurl+'?action=eme_discountgroups_list',
                deleteAction: ajaxurl+'?action=eme_manage_discountgroups&do_action=deleteDiscountGroups&eme_admin_nonce='+emediscounts.translate_adminnonce
            },
            fields: {
                id: {
                    key: true,
                    create: false,
                    edit: false,
                    list: false
                },
                name: {
		    title: emediscounts.translate_name,
                },
                description: {
		    title: emediscounts.translate_description
                },
                maxdiscounts: {
		    title: emediscounts.translate_maxdiscounts
                }
            }
        });
 
        // Load list from server, but only if the container is there
        if (jQuery('#DiscountsTableContainer').length) {
           jQuery('#DiscountsTableContainer').jtable('load');
        }
        if (jQuery('#DiscountGroupsTableContainer').length) {
           jQuery('#DiscountGroupsTableContainer').jtable('load');
        }
 
        // Actions button
        jQuery('#DiscountsActionsButton').on("click",function () {
           var selectedRows = jQuery('#DiscountsTableContainer').jtable('selectedRows');
           var do_action = jQuery('#eme_admin_action').val();
           var action_ok=1;
           if (selectedRows.length > 0) {
              if ((do_action=='deleteDiscounts') && !confirm(emediscounts.translate_areyousuretodeleteselected)) {
                 action_ok=0;
              }
              if (action_ok==1) {
                 jQuery('#DiscountsActionsButton').text(emediscounts.translate_pleasewait);
                 var ids = [];
                 selectedRows.each(function () {
                   ids.push(jQuery(this).data('record')['id']);
                 });

                 var idsjoined = ids.join(); //will be such a string '2,5,7'
                 jQuery.post(ajaxurl, {'id': idsjoined, 'action': 'eme_manage_discounts', 'do_action': do_action, 'eme_admin_nonce': emediscounts.translate_adminnonce }, function() {
			 jQuery('#DiscountsTableContainer').jtable('reload');
			 jQuery('#DiscountsActionsButton').text(emediscounts.translate_apply);
			 if (do_action=='deleteDiscounts') {
				 jQuery('div#discounts-message').html(emediscounts.translate_deleted);
				 jQuery('div#discounts-message').show();
				 jQuery('div#discounts-message').delay(3000).fadeOut('slow');
			 }
                 });
              }
           }
           // return false to make sure the real form doesn't submit
           return false;
        });
 
        // Actions button
        jQuery('#DiscountGroupsActionsButton').on("click",function () {
           var selectedRows = jQuery('#DiscountGroupsTableContainer').jtable('selectedRows');
           var do_action = jQuery('#eme_admin_action').val();
           var action_ok=1;
           if (selectedRows.length > 0) {
              if ((do_action=='deleteDiscountGroups') && !confirm(emediscounts.translate_areyousuretodeleteselected)) {
                 action_ok=0;
              }
              if (action_ok==1) {
                 jQuery('#DiscountGroupsActionsButton').text(emediscounts.translate_pleasewait);
                 var ids = [];
                 selectedRows.each(function () {
                   ids.push(jQuery(this).data('record')['id']);
                 });

                 var idsjoined = ids.join(); //will be such a string '2,5,7'
                 jQuery.post(ajaxurl, {'id': idsjoined, 'action': 'eme_manage_discountgroups', 'do_action': do_action, 'eme_admin_nonce': emediscounts.translate_adminnonce }, function() {
			 jQuery('#DiscountGroupsTableContainer').jtable('reload');
			 jQuery('#DiscountGroupsActionsButton').text(emediscounts.translate_apply);
			 if (do_action=='deleteDiscountGroups') {
				 jQuery('div#discountgroups-message').html(emediscounts.translate_deleted);
				 jQuery('div#discountgroups-message').show();
				 jQuery('div#discountgroups-message').delay(3000).fadeOut('slow');
			 }
                 });
              }
           }
           // return false to make sure the real form doesn't submit
           return false;
        });
});
